#property tester_file "data.bin"

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
// 
#include <AnnealingMethod.mqh>
#include <FrameAnnealingMethod.mqh>
//   
AnnealingMethod Optim;
FrameAnnealingMethod Frame;
Input InputMass[];            //  
double Fopt=0;                //  
int it_agent=0;               //     
uint alg_err=0;               // 
//   
sinput int iteration=170;     // 
sinput int method=2;          //0 -  ,1 -  , 2 -  
sinput double CoeffOfTemp=1;  //    
sinput double CoeffOfMinTemp=0; //   
                                //sinput double CoeffOfProb=10;  //       
sinput double Func0=-10000;   //   
sinput double P1=1;           //     p1
sinput double P2=2;           //     p2
sinput int Crit=0;            //   
sinput int ModOfAlg=1;        //  
sinput bool ManyPoint=false;   //   

double Inputs[];
int Index[];

void CorrectInputsRead()
{
  int Count = 0;

  const int Size = ArrayResize(Inputs, ArrayResize(Index, ArraySize(InputMass)));

  for (int i = 0; i < Size; i++)
    if (InputMass[i].Step)
    {
      InputMass[Count] = InputMass[i];
      Index[Count] = i;

      Count++;
    }
    else
      Inputs[i] = InputMass[i].Value;

  ArrayResize(Index, ArrayResize(InputMass, Count));
}

void CorrectInputsWrite()
{
  Input Tmp[];
  const int Size1 = ArrayCopy(Tmp, InputMass);
  const int Size2 = ArrayResize(InputMass, ArraySize(Inputs));

  for (int i = 0; i < Size2; i++)
  {
    InputMass[i].Value = Inputs[i];

    InputMass[i].Step = 0;
  }

  for (int i = 0; i < Size1; i++)
    InputMass[Index[i]] = Tmp[i];
}

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(void)
  {
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+
   if(MQL5InfoInteger(MQL5_OPTIMIZATION))
     {
      alg_err=Optim.ReadData(InputMass,Fopt,it_agent);
      if(alg_err==0)
        {
         CorrectInputsRead();

         //     ,      
         if(Fopt==Func0)
           {
            if(ManyPoint)
               for(int i=0;i<ArraySize(InputMass);i++)
                 {
                  InputMass[i].Value=Optim.UniformValue(InputMass[i].Start,InputMass[i].Stop,InputMass[i].Step);
                  InputMass[i].BestValue=InputMass[i].Value;
                 }
           }
         else
            Optim.GetParams(method,InputMass,CoeffOfMinTemp);//  
         //  
         for(int i=0;i<ArraySize(InputMass);i++)
           Inputs[Index[i]] = InputMass[i].Value;
        }
      else
        {
         Print("Error reading file");
         return(INIT_FAILED);
        }
     }//end if(MQL5InfoInteger(MQL5_OPTIMIZATION))

     return(OnInit2());
  }

#define OnInit OnInit2

#include <fxsaber\Expert.mqh> // https://www.mql5.com/ru/code/19003

void OnTesterInit()
  {
  MqlParam Params[];
  string SParams[];

  //     
  if (EXPERT::Parameters(0, Params, SParams))
  {
    //  string-input   ,   
    ArrayResize(SParams, ArraySize(SParams) - 10); // 10 -  sinput,    mqh.

  // 
     Optim.RunOptimization(SParams,iteration,Func0,CoeffOfTemp);
  //  
     Frame.FrameInit(SParams);
  }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
   Frame.FrameToFile(4);
   Frame.FrameDeinit();
  }
//+------------------------------------------------------------------+
double OnTester()
  {
   int i=0;// 
   int count=0;// 
  //       
   for(i=0;i<ArraySize(InputMass);i++)
      if(InputMass[i].Temp<CoeffOfMinTemp*Optim.Distance(InputMass[i].Start,InputMass[i].Stop))
         count++;
   if(count==ArraySize(InputMass))
      Frame.FrameTester(0,0,InputMass,-1,it_agent);//   c    id=-1
   else
     {
      double Fnew=Optim.GetFunction(Crit);//   
      if((Crit!=5) && (Crit!=6) && (Crit!=11) && (Crit!=12))//    
        {
         if(Fnew>Fopt)
            Fopt=Fnew;
         else
           {
            if(Optim.Probability(Fopt-Fnew,CoeffOfTemp*InputMass[0].Temp/Optim.Distance(InputMass[0].Start,InputMass[0].Stop)))
               Fopt=Fnew;
           }
        }
      else //    
        {
         if(Fnew<Fopt)
            Fopt=Fnew;
         else
           {
            if(Optim.Probability(Fnew-Fopt,CoeffOfTemp*InputMass[0].Temp/Optim.Distance(InputMass[0].Start,InputMass[0].Stop)))
               Fopt=Fnew;
           }
        }
      //   
      if(Fopt==Fnew)
         for(i=0;i<ArraySize(InputMass);i++)
            InputMass[i].BestValue=InputMass[i].Value;
      // 
      if(((ModOfAlg==0) && (Fnew==Fopt)) || (ModOfAlg==1))
        {
         for(i=0;i<ArraySize(InputMass);i++)
            //  InputMass[i].Temp=Optim.GetT(method,CoeffOfTemp*Optim.Distance(InputMass[i].Start,InputMass[i].Stop),it_agent,ArraySize(InputMass),P1,P2);
            InputMass[i].Temp=Optim.GetT(method,CoeffOfTemp*Optim.Distance(InputMass[i].Start,InputMass[i].Stop),InputMass[i].Temp,it_agent,ArraySize(InputMass),P1,P2);
        }
      Frame.FrameTester(Fnew,Fopt,InputMass,iteration,it_agent);//  
      it_agent++;//  

      CorrectInputsWrite();
      alg_err=Optim.WriteData(InputMass,Fopt,it_agent);//    
      if(alg_err!=0)
         return alg_err;
     }
   return Fopt;
  }
//+------------------------------------------------------------------+
void OnTesterPass()
  {
   Frame.FrameTesterPass(Crit);//     
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   Frame.FrameOnChartEvent(id,lparam,dparam,sparam,Crit); //    
  }
//+------------------------------------------------------------------+
